> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Creates a pre-shared key

> Creates a pre-shared key for the specified data product with the given description and validity period.



## OpenAPI

````yaml post /api/dataproduct/{dataproduct_id}/psk
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/dataproduct/{dataproduct_id}/psk:
    post:
      tags:
        - Data products
      summary: Creates a pre-shared key
      description: >-
        Creates a pre-shared key for the specified data product with the given
        description and validity period.
      operationId: create_preshared_key_api_dataproduct__dataproduct_id__psk_post
      parameters:
        - name: dataproduct_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            description: Unique ID of the data product for the creation of pre-shared key.
            title: Dataproduct Id
          description: Unique ID of the data product for the creation of pre-shared key.
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreatePresharedKeyRequest'
      responses:
        '200':
          description: Pre-shared key created successfully.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreatePresharedKeyResponse'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    CreatePresharedKeyRequest:
      properties:
        description:
          type: string
          title: Description
          description: A brief description of the pre-shared key's purpose.
        validity_days:
          type: integer
          title: Validity Days
          description: Number of days the key is valid for.
      type: object
      required:
        - description
        - validity_days
      title: CreatePresharedKeyRequest
    CreatePresharedKeyResponse:
      properties:
        psk:
          type: string
          format: uuid
          title: Psk
          description: The unique ID of the generated pre-shared key.
        description:
          type: string
          title: Description
          description: The description provided for this key.
        valid_until:
          type: string
          format: date-time
          title: Valid Until
          description: Expiration date and time of the key.
      type: object
      required:
        - psk
        - description
        - valid_until
      title: CreatePresharedKeyResponse
    ErrorResponse:
      properties:
        error:
          type: string
          title: Error
          description: A brief description of the error that occurred.
        code:
          type: integer
          title: Code
          description: The HTTP status code associated with the error.
          default: 500
      type: object
      required:
        - error
      title: ErrorResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````